uniform mat4 transform;
uniform mat4 modelview;
uniform mat3 normalMatrix;

uniform vec4 lightPosition;

attribute vec4 position;
attribute vec4 color;
attribute vec3 normal;

varying vec4 vertColor;
varying vec3 vertNormal;
varying vec3 vertLightDir;

void main() {
  gl_Position = transform * position;
  vec4 tp = modelview * position;

  vertNormal = normalMatrix * normal;
  vertLightDir = normalize(lightPosition.xyz - tp.xyz);
  vertColor = color;
}