uniform mat4 transform;
uniform mat4 modelview;
uniform mat3 normalMatrix;
uniform mat4 texMatrix;

uniform vec4 lightPosition;
uniform vec3 lightDiffuse;

attribute vec4 position;
attribute vec4 color;
attribute vec2 texCoord;
attribute vec3 normal;

varying vec4 vertColor;
varying vec4 vertTexCoord;

void main() {
  gl_Position = transform * position;
  vec4 tp = modelview * position;

  vec3 tn = normalMatrix * normal;

  vec3 lp = normalize(lightPosition.xyz - tp.xyz);

  float lumi = abs(dot(lp, tn));

  vertColor = vec4(lumi, lumi, lumi, 1) * vec4(lightDiffuse, 1) * color;

  vertTexCoord = texMatrix * vec4(texCoord, 0, 0);
}