uniform sampler2D texture;
uniform vec3 lightDiffuse;

varying vec4 vertColor;
varying vec3 vertNormal;
varying vec3 vertLightDir;
varying vec4 vertTexCoord;
varying vec4 vertPointToEye;

void main() {
  vec4 texColor = texture2D(texture, vertTexCoord.st);	
  float lumi = abs(dot(vertLightDir, vertNormal));

  float refl = dot(vertPointToEye.xyz, vertNormal);

  vec4 diffuse = vec4(lumi, lumi, lumi, 1) * vec4(lightDiffuse, 1);
  vec4 specular = pow(max(0.0, refl), 10) * vec4(0, 1, 0, 1);

  gl_FragColor = (diffuse + specular) * texColor * vertColor;  
}