uniform mat4 transform;
uniform mat4 modelview;
uniform mat3 normalMatrix;
uniform mat4 texMatrix;

uniform vec4 lightPosition;

attribute vec4 position;
attribute vec4 color;
attribute vec3 normal;
attribute vec2 texCoord;

varying vec4 vertPos;
varying vec4 vertColor;
varying vec3 vertNormal;
varying vec3 vertLightDir;
varying vec4 vertTexCoord;
varying vec4 vertPointToEye;

void main() {
  gl_Position = transform * position;
  vec4 tp = modelview * position;
  vertPointToEye = normalize(-tp);
  vertPos = tp;

  vertNormal = normalMatrix * normal;
  vertLightDir = normalize(lightPosition.xyz - tp.xyz);
  vertColor = color;
  vertTexCoord = texMatrix * vec4(texCoord, 0, 0);
}